/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 52 "yacc.ypp"


#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include "common.h"
#include "lex.h"
#include "fim_interpreter.h"
#include "fim.h"

#ifndef yylex
#define  yylex lexer->yylex
#endif

/* See fim_interpreter.cpp for prototypes */

#line 88 "yacc.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "yacc.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_INTEGER = 3,                    /* INTEGER  */
  YYSYMBOL_STRING = 4,                     /* STRING  */
  YYSYMBOL_SLASH_AND_REGEXP = 5,           /* SLASH_AND_REGEXP  */
  YYSYMBOL_QUOTED_FLOAT = 6,               /* QUOTED_FLOAT  */
  YYSYMBOL_UNQUOTED_FLOAT = 7,             /* UNQUOTED_FLOAT  */
  YYSYMBOL_IDENTIFIER = 8,                 /* IDENTIFIER  */
  YYSYMBOL_FILE_PATH = 9,                  /* FILE_PATH  */
  YYSYMBOL_COMMAND = 10,                   /* COMMAND  */
  YYSYMBOL_WHILE = 11,                     /* WHILE  */
  YYSYMBOL_IF = 12,                        /* IF  */
  YYSYMBOL_DO = 13,                        /* DO  */
  YYSYMBOL_ELSE = 14,                      /* ELSE  */
  YYSYMBOL_SYSTEM = 15,                    /* SYSTEM  */
  YYSYMBOL_AND = 16,                       /* AND  */
  YYSYMBOL_BAND = 17,                      /* BAND  */
  YYSYMBOL_OR = 18,                        /* OR  */
  YYSYMBOL_BOR = 19,                       /* BOR  */
  YYSYMBOL_NOT = 20,                       /* NOT  */
  YYSYMBOL_FESF = 21,                      /* FESF  */
  YYSYMBOL_22_ = 22,                       /* ';'  */
  YYSYMBOL_23_ = 23,                       /* '}'  */
  YYSYMBOL_24_ = 24,                       /* '{'  */
  YYSYMBOL_GE = 25,                        /* GE  */
  YYSYMBOL_LE = 26,                        /* LE  */
  YYSYMBOL_EQ = 27,                        /* EQ  */
  YYSYMBOL_REGEXP_MATCH = 28,              /* REGEXP_MATCH  */
  YYSYMBOL_NE = 29,                        /* NE  */
  YYSYMBOL_30_ = 30,                       /* '>'  */
  YYSYMBOL_31_ = 31,                       /* '<'  */
  YYSYMBOL_32_ = 32,                       /* '.'  */
  YYSYMBOL_33_ = 33,                       /* '('  */
  YYSYMBOL_34_ = 34,                       /* ')'  */
  YYSYMBOL_35_ = 35,                       /* '%'  */
  YYSYMBOL_36_ = 36,                       /* '+'  */
  YYSYMBOL_37_ = 37,                       /* '-'  */
  YYSYMBOL_38_ = 38,                       /* '*'  */
  YYSYMBOL_39_ = 39,                       /* '/'  */
  YYSYMBOL_UMINUS = 40,                    /* UMINUS  */
  YYSYMBOL_41_ = 41,                       /* ','  */
  YYSYMBOL_42_ = 42,                       /* '='  */
  YYSYMBOL_YYACCEPT = 43,                  /* $accept  */
  YYSYMBOL_program = 44,                   /* program  */
  YYSYMBOL_statement_list = 45,            /* statement_list  */
  YYSYMBOL_non_atomic_statements_block = 46, /* non_atomic_statements_block  */
  YYSYMBOL_statements_block = 47,          /* statements_block  */
  YYSYMBOL_conditional_statement = 48,     /* conditional_statement  */
  YYSYMBOL_if_statement = 49,              /* if_statement  */
  YYSYMBOL_loop_statement = 50,            /* loop_statement  */
  YYSYMBOL_atomic_statements_block = 51,   /* atomic_statements_block  */
  YYSYMBOL_statement = 52,                 /* statement  */
  YYSYMBOL_arguments = 53,                 /* arguments  */
  YYSYMBOL_expression = 54                 /* expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  57
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   340

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  12
/* YYNRULES -- Number of rules.  */
#define YYNRULES  72
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  131

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   282


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    35,     2,     2,
      33,    34,    38,    36,    41,    37,    32,    39,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    22,
      31,    42,    30,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    24,     2,    23,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    25,    26,    27,
      28,    29,    40
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   130,   130,   131,   139,   140,   141,   142,   146,   147,
     148,   154,   155,   162,   163,   173,   174,   183,   184,   188,
     189,   190,   215,   218,   219,   220,   222,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   234,   235,   236,   238,
     239,   241,   242,   251,   252,   254,   284,   285,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   326,   329,   330,
     331,   332,   333
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "INTEGER", "STRING",
  "SLASH_AND_REGEXP", "QUOTED_FLOAT", "UNQUOTED_FLOAT", "IDENTIFIER",
  "FILE_PATH", "COMMAND", "WHILE", "IF", "DO", "ELSE", "SYSTEM", "AND",
  "BAND", "OR", "BOR", "NOT", "FESF", "';'", "'}'", "'{'", "GE", "LE",
  "EQ", "REGEXP_MATCH", "NE", "'>'", "'<'", "'.'", "'('", "')'", "'%'",
  "'+'", "'-'", "'*'", "'/'", "UMINUS", "','", "'='", "$accept", "program",
  "statement_list", "non_atomic_statements_block", "statements_block",
  "conditional_statement", "if_statement", "loop_statement",
  "atomic_statements_block", "statement", "arguments", "expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-35)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-68)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     159,    -5,   -35,   -34,   -30,    55,    -9,     0,   159,    62,
     159,     9,    15,    20,    34,   -35,   159,   -35,   -35,   -35,
     -35,   -35,    13,    62,   159,   -35,    35,   -35,   -35,   -35,
     -35,   -35,   -35,   -35,   -35,    62,    62,    62,    62,   -35,
     122,    62,    62,   -35,    45,    49,   -35,    44,    22,    39,
      46,    59,    63,    66,   -35,   -35,   -35,   -35,   -35,    97,
     -35,    83,    99,   -35,   173,   -35,   269,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,   -35,   197,   221,    85,   101,   -35,
     -35,   -35,   -35,   -35,   -35,   -35,   105,   -35,   -35,    62,
      62,   -35,   301,   301,   286,   286,    41,    41,    41,    41,
      41,    41,    41,    48,   107,    52,   -10,   -35,   -35,   159,
     159,    62,   -35,   -35,    -7,   -35,   117,   245,   159,   -35,
     -35
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,    39,    26,     0,     0,    41,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     3,    12,     7,    10,    13,
      14,    11,     4,    25,     0,    35,     0,    34,    33,    69,
      72,    70,    71,    68,    42,     0,     0,     0,     0,    43,
      46,     0,     0,    12,     0,     0,    22,     0,     0,     0,
       0,    40,     0,     0,    32,    31,    30,     1,     6,    19,
      44,     0,     0,    50,     0,    67,    45,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,     0,     0,    19,     8,
      29,    28,    27,    38,    37,    36,    20,     5,     9,    23,
       0,    48,    60,    61,    58,    59,    62,    63,    65,    66,
      64,    57,    56,    49,    51,    52,    53,    54,    55,     0,
       0,     0,    21,    24,    53,    17,    15,     0,     0,    18,
      16
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -35,   -35,     1,    -8,    -6,   -35,   -35,   -35,   -35,    -4,
      -3,   -28
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      39,    40
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,    27,    44,    23,    45,    28,    46,    63,    64,    65,
      66,    47,    48,    85,    86,    49,    50,    58,    51,    24,
      60,    52,    53,    54,    41,    61,    55,    56,   -67,   -67,
      25,    82,    83,    42,    57,    59,    26,    84,    62,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    87,    90,    29,    30,
      97,    31,    32,    33,    34,    29,    30,    89,    31,    32,
      33,    88,   124,    78,    91,    35,    79,    80,   100,    82,
      83,    92,    35,    79,    80,   100,    82,    83,    36,   100,
      82,    83,    37,   127,    93,    36,   123,    38,    94,    37,
       1,    95,     2,     3,     4,     5,    98,    99,     6,     7,
       8,    43,    43,   125,   126,    45,    45,     9,   121,    96,
      43,    10,   130,    96,    45,    29,    30,   122,    31,    32,
      33,   128,     0,    11,    12,    13,     0,     0,    67,    68,
      69,    70,    35,    80,   100,    82,    83,    71,    72,    73,
      74,    75,    76,    77,    78,    36,     0,    79,    80,    81,
      82,    83,     1,     0,     2,     3,     4,     5,     0,     0,
       6,     7,     8,     0,     0,     0,     0,     0,     0,     9,
       0,     0,     0,    10,     0,     0,     0,     0,     0,    67,
      68,    69,    70,     0,     0,    11,    12,    13,    71,    72,
      73,    74,    75,    76,    77,    78,     0,   101,    79,    80,
     100,    82,    83,    67,    68,    69,    70,     0,     0,     0,
       0,     0,    71,    72,    73,    74,    75,    76,    77,    78,
       0,   119,    79,    80,   100,    82,    83,    67,    68,    69,
      70,     0,     0,     0,     0,     0,    71,    72,    73,    74,
      75,    76,    77,    78,     0,   120,    79,    80,   100,    82,
      83,    67,    68,    69,    70,     0,     0,     0,     0,     0,
      71,    72,    73,    74,    75,    76,    77,    78,     0,   129,
      79,    80,   100,    82,    83,    67,    68,    69,    70,     0,
       0,     0,     0,     0,    71,    72,    73,    74,    75,    76,
      77,    78,    67,    68,    79,    80,   100,    82,    83,     0,
       0,    71,    72,    73,    74,    75,    76,    77,    78,     0,
       0,    79,    80,   100,    82,    83,    71,    72,    73,    74,
      75,    76,    77,    78,     0,     0,    79,    80,   100,    82,
      83
};

static const yytype_int16 yycheck[] =
{
       8,    35,     8,     8,     8,    35,     9,    35,    36,    37,
      38,    10,     3,    41,    42,     6,     7,    16,     3,    24,
      23,     6,     7,     3,    33,    24,     6,     7,    38,    39,
      35,    38,    39,    33,     0,    22,    41,    40,     3,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    11,    35,     3,     4,
      59,     6,     7,     8,     9,     3,     4,    23,     6,     7,
       8,    22,   100,    32,    35,    20,    35,    36,    37,    38,
      39,    35,    20,    35,    36,    37,    38,    39,    33,    37,
      38,    39,    37,   121,    35,    33,    99,    42,    35,    37,
       3,    35,     5,     6,     7,     8,    23,     8,    11,    12,
      13,   119,   120,   119,   120,   119,   120,    20,    33,    22,
     128,    24,   128,    22,   128,     3,     4,    22,     6,     7,
       8,    14,    -1,    36,    37,    38,    -1,    -1,    16,    17,
      18,    19,    20,    36,    37,    38,    39,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    -1,    35,    36,    37,
      38,    39,     3,    -1,     5,     6,     7,     8,    -1,    -1,
      11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    16,
      17,    18,    19,    -1,    -1,    36,    37,    38,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    34,    35,    36,
      37,    38,    39,    16,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    34,    35,    36,    37,    38,    39,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    34,    35,    36,    37,    38,
      39,    16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    34,
      35,    36,    37,    38,    39,    16,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    16,    17,    35,    36,    37,    38,    39,    -1,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    35,    36,    37,    38,    39,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    35,    36,    37,    38,
      39
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     5,     6,     7,     8,    11,    12,    13,    20,
      24,    36,    37,    38,    44,    45,    46,    47,    48,    49,
      50,    51,    52,     8,    24,    35,    41,    35,    35,     3,
       4,     6,     7,     8,     9,    20,    33,    37,    42,    53,
      54,    33,    33,    46,    47,    52,    53,    45,     3,     6,
       7,     3,     6,     7,     3,     6,     7,     0,    45,    22,
      53,    45,     3,    54,    54,    54,    54,    16,    17,    18,
      19,    25,    26,    27,    28,    29,    30,    31,    32,    35,
      36,    37,    38,    39,    53,    54,    54,    11,    22,    23,
      35,    35,    35,    35,    35,    35,    22,    45,    23,     8,
      37,    34,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    34,
      34,    33,    22,    53,    54,    47,    47,    54,    14,    34,
      47
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    43,    44,    44,    45,    45,    45,    45,    46,    46,
      46,    47,    47,    48,    48,    49,    49,    50,    50,    51,
      51,    51,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    53,    53,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     3,     2,     1,     3,     4,
       1,     1,     1,     1,     1,     5,     7,     5,     6,     2,
       3,     4,     2,     4,     5,     2,     1,     3,     3,     3,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     1,
       2,     1,     2,     2,     3,     3,     1,     2,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     1,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* STRING  */
#line 114 "yacc.ypp"
            {fim_free(((*yyvaluep).sValue));}
#line 995 "yacc.tab.cpp"
        break;

    case YYSYMBOL_SLASH_AND_REGEXP: /* SLASH_AND_REGEXP  */
#line 114 "yacc.ypp"
            {fim_free(((*yyvaluep).sValue));}
#line 1001 "yacc.tab.cpp"
        break;

    case YYSYMBOL_IDENTIFIER: /* IDENTIFIER  */
#line 114 "yacc.ypp"
            {fim_free(((*yyvaluep).sValue));}
#line 1007 "yacc.tab.cpp"
        break;

    case YYSYMBOL_FILE_PATH: /* FILE_PATH  */
#line 114 "yacc.ypp"
            {fim_free(((*yyvaluep).sValue));}
#line 1013 "yacc.tab.cpp"
        break;

    case YYSYMBOL_COMMAND: /* COMMAND  */
#line 114 "yacc.ypp"
            {fim_free(((*yyvaluep).sValue));}
#line 1019 "yacc.tab.cpp"
        break;

    case YYSYMBOL_statement_list: /* statement_list  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1025 "yacc.tab.cpp"
        break;

    case YYSYMBOL_non_atomic_statements_block: /* non_atomic_statements_block  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1031 "yacc.tab.cpp"
        break;

    case YYSYMBOL_statements_block: /* statements_block  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1037 "yacc.tab.cpp"
        break;

    case YYSYMBOL_conditional_statement: /* conditional_statement  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1043 "yacc.tab.cpp"
        break;

    case YYSYMBOL_if_statement: /* if_statement  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1049 "yacc.tab.cpp"
        break;

    case YYSYMBOL_loop_statement: /* loop_statement  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1055 "yacc.tab.cpp"
        break;

    case YYSYMBOL_atomic_statements_block: /* atomic_statements_block  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1061 "yacc.tab.cpp"
        break;

    case YYSYMBOL_statement: /* statement  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1067 "yacc.tab.cpp"
        break;

    case YYSYMBOL_arguments: /* arguments  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1073 "yacc.tab.cpp"
        break;

    case YYSYMBOL_expression: /* expression  */
#line 113 "yacc.ypp"
            {freeNode(((*yyvaluep).nPtr));}
#line 1079 "yacc.tab.cpp"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* program: %empty  */
#line 130 "yacc.ypp"
          {}
#line 1349 "yacc.tab.cpp"
    break;

  case 3: /* program: statement_list  */
#line 131 "yacc.ypp"
                         { ex((yyvsp[0].nPtr)); FIM_FREENODE((yyvsp[0].nPtr)); }
#line 1355 "yacc.tab.cpp"
    break;

  case 4: /* statement_list: statement  */
#line 139 "yacc.ypp"
                    { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1361 "yacc.tab.cpp"
    break;

  case 5: /* statement_list: statement ';' statement_list  */
#line 140 "yacc.ypp"
                                       { (yyval.nPtr) = FIM_OPR(';', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1367 "yacc.tab.cpp"
    break;

  case 6: /* statement_list: non_atomic_statements_block statement_list  */
#line 141 "yacc.ypp"
                                                    { (yyval.nPtr) = FIM_OPR(';', 2, (yyvsp[-1].nPtr), (yyvsp[0].nPtr)); }
#line 1373 "yacc.tab.cpp"
    break;

  case 7: /* statement_list: statements_block  */
#line 142 "yacc.ypp"
                           { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1379 "yacc.tab.cpp"
    break;

  case 8: /* non_atomic_statements_block: '{' statement_list '}'  */
#line 146 "yacc.ypp"
                                 { (yyval.nPtr) = FIM_OPR(';', 2, (yyvsp[-1].nPtr), NULL); }
#line 1385 "yacc.tab.cpp"
    break;

  case 9: /* non_atomic_statements_block: INTEGER '{' statement_list '}'  */
#line 147 "yacc.ypp"
                                         { if((yyvsp[-3].iValue)>0){(yyval.nPtr) = FIM_OPR('r',2,FIM_OPR(';', 2, (yyvsp[-1].nPtr), NULL), FIM_ICON((yyvsp[-3].iValue))); }}
#line 1391 "yacc.tab.cpp"
    break;

  case 10: /* non_atomic_statements_block: conditional_statement  */
#line 148 "yacc.ypp"
                                { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1397 "yacc.tab.cpp"
    break;

  case 11: /* statements_block: atomic_statements_block  */
#line 154 "yacc.ypp"
                                  { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1403 "yacc.tab.cpp"
    break;

  case 12: /* statements_block: non_atomic_statements_block  */
#line 155 "yacc.ypp"
                                      { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1409 "yacc.tab.cpp"
    break;

  case 13: /* conditional_statement: if_statement  */
#line 162 "yacc.ypp"
                         { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1415 "yacc.tab.cpp"
    break;

  case 14: /* conditional_statement: loop_statement  */
#line 163 "yacc.ypp"
                         { (yyval.nPtr) = (yyvsp[0].nPtr); }
#line 1421 "yacc.tab.cpp"
    break;

  case 15: /* if_statement: IF '(' expression ')' statements_block  */
#line 173 "yacc.ypp"
                                                 { (yyval.nPtr) = FIM_OPR(IF, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1427 "yacc.tab.cpp"
    break;

  case 16: /* if_statement: IF '(' expression ')' statements_block ELSE statements_block  */
#line 174 "yacc.ypp"
                                                                       { (yyval.nPtr) = FIM_OPR(IF, 3, (yyvsp[-4].nPtr), (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1433 "yacc.tab.cpp"
    break;

  case 17: /* loop_statement: WHILE '(' expression ')' statements_block  */
#line 183 "yacc.ypp"
                                                    { (yyval.nPtr) = FIM_OPR(WHILE, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1439 "yacc.tab.cpp"
    break;

  case 18: /* loop_statement: DO statements_block WHILE '(' expression ')'  */
#line 184 "yacc.ypp"
                                                       { (yyval.nPtr) = FIM_OPR(WHILE, 2, (yyvsp[-1].nPtr), (yyvsp[-4].nPtr)); }
#line 1445 "yacc.tab.cpp"
    break;

  case 19: /* atomic_statements_block: statement ';'  */
#line 188 "yacc.ypp"
                      { (yyval.nPtr) = FIM_OPR(';', 2, (yyvsp[-1].nPtr), NULL); }
#line 1451 "yacc.tab.cpp"
    break;

  case 20: /* atomic_statements_block: statement ';' ';'  */
#line 189 "yacc.ypp"
                            { (yyval.nPtr) = FIM_OPR(';', 2, (yyvsp[-2].nPtr), NULL); /*a hack for handling redundancy */ }
#line 1457 "yacc.tab.cpp"
    break;

  case 21: /* atomic_statements_block: statement ';' ';' ';'  */
#line 190 "yacc.ypp"
                                { (yyval.nPtr) = FIM_OPR(';', 2, (yyvsp[-3].nPtr), NULL); /*a hack for handling redundancy */ }
#line 1463 "yacc.tab.cpp"
    break;

  case 22: /* statement: NOT arguments  */
#line 215 "yacc.ypp"
                                { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SYSTEM)),(yyvsp[0].nPtr)); }
#line 1469 "yacc.tab.cpp"
    break;

  case 23: /* statement: INTEGER ',' INTEGER IDENTIFIER  */
#line 218 "yacc.ypp"
                                          { (yyval.nPtr) = FIM_OPR(FESF,3,FIM_ICON((yyvsp[-3].iValue)),FIM_ICON((yyvsp[-1].iValue)),FIM_SCON((yyvsp[0].sValue))); }
#line 1475 "yacc.tab.cpp"
    break;

  case 24: /* statement: INTEGER ',' INTEGER IDENTIFIER arguments  */
#line 219 "yacc.ypp"
                                                    { (yyval.nPtr) = FIM_OPR(FESF,4,FIM_ICON((yyvsp[-4].iValue)),FIM_ICON((yyvsp[-2].iValue)),FIM_SCON((yyvsp[-1].sValue)),(yyvsp[0].nPtr)); }
#line 1481 "yacc.tab.cpp"
    break;

  case 25: /* statement: INTEGER IDENTIFIER  */
#line 220 "yacc.ypp"
                             { if((yyvsp[-1].iValue)>0){(yyval.nPtr) = FIM_OPR('r',2,FIM_OPR('x',1,FIM_SCON((yyvsp[0].sValue))),FIM_ICON((yyvsp[-1].iValue))); }}
#line 1487 "yacc.tab.cpp"
    break;

  case 26: /* statement: SLASH_AND_REGEXP  */
#line 222 "yacc.ypp"
                           { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_GOTO)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupsqstr ((yyvsp[0].sValue)))))); fim_free((yyvsp[0].sValue)); }
#line 1493 "yacc.tab.cpp"
    break;

  case 27: /* statement: '+' UNQUOTED_FLOAT '%'  */
#line 224 "yacc.ypp"
                                   { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('+',((float)(yyvsp[-1].fValue)),'%'))))); }
#line 1499 "yacc.tab.cpp"
    break;

  case 28: /* statement: '+' QUOTED_FLOAT '%'  */
#line 225 "yacc.ypp"
                                 { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('+',((float)(yyvsp[-1].fValue)),'%'))))); }
#line 1505 "yacc.tab.cpp"
    break;

  case 29: /* statement: '+' INTEGER '%'  */
#line 226 "yacc.ypp"
                          { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('+',((double)(yyvsp[-1].iValue)),'%'))))); }
#line 1511 "yacc.tab.cpp"
    break;

  case 30: /* statement: '*' UNQUOTED_FLOAT  */
#line 227 "yacc.ypp"
                             { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('*',((float)(yyvsp[0].fValue))))))); }
#line 1517 "yacc.tab.cpp"
    break;

  case 31: /* statement: '*' QUOTED_FLOAT  */
#line 228 "yacc.ypp"
                           { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('*',((float)(yyvsp[0].fValue))))))); }
#line 1523 "yacc.tab.cpp"
    break;

  case 32: /* statement: '*' INTEGER  */
#line 229 "yacc.ypp"
                      { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('*',((float)(yyvsp[0].iValue))))))); }
#line 1529 "yacc.tab.cpp"
    break;

  case 33: /* statement: UNQUOTED_FLOAT '%'  */
#line 230 "yacc.ypp"
                             {if((yyvsp[-1].fValue)>0.0){(yyval.nPtr)=FIM_OPR('x',2,FIM_SCON(dupstr(FIM_VID_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr(((float)(yyvsp[-1].fValue))/100.0f)))));}else { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('-',-((float)(yyvsp[-1].fValue)),'%'))))); } }
#line 1535 "yacc.tab.cpp"
    break;

  case 34: /* statement: QUOTED_FLOAT '%'  */
#line 231 "yacc.ypp"
                           {if((yyvsp[-1].fValue)>0.0){(yyval.nPtr)=FIM_OPR('x',2,FIM_SCON(dupstr(FIM_VID_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr(((float)(yyvsp[-1].fValue))/100.0f)))));}else { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('-',-((float)(yyvsp[-1].fValue)),'%'))))); } }
#line 1541 "yacc.tab.cpp"
    break;

  case 35: /* statement: INTEGER '%'  */
#line 232 "yacc.ypp"
                    {{(yyval.nPtr)=FIM_OPR('x',2,FIM_SCON(dupstr(FIM_VID_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr(((float)(yyvsp[-1].iValue)),'%')))));}}
#line 1547 "yacc.tab.cpp"
    break;

  case 36: /* statement: '-' UNQUOTED_FLOAT '%'  */
#line 234 "yacc.ypp"
                                   { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('-',((float)(yyvsp[-1].fValue)),'%'))))); }
#line 1553 "yacc.tab.cpp"
    break;

  case 37: /* statement: '-' QUOTED_FLOAT '%'  */
#line 235 "yacc.ypp"
                                 { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('-',((float)(yyvsp[-1].fValue)),'%'))))); }
#line 1559 "yacc.tab.cpp"
    break;

  case 38: /* statement: '-' INTEGER '%'  */
#line 236 "yacc.ypp"
                          { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_SCALE)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('-',((float)(yyvsp[-1].iValue)),'%'))))); }
#line 1565 "yacc.tab.cpp"
    break;

  case 39: /* statement: INTEGER  */
#line 238 "yacc.ypp"
                          { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_GOTO)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr(    (yyvsp[0].iValue)))))); }
#line 1571 "yacc.tab.cpp"
    break;

  case 40: /* statement: '-' INTEGER  */
#line 239 "yacc.ypp"
                          { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_GOTO)),FIM_OPR('a',1,FIM_OPR('a',1,FIM_SCON(dupnstr('-',(yyvsp[0].iValue)))))); }
#line 1577 "yacc.tab.cpp"
    break;

  case 41: /* statement: IDENTIFIER  */
#line 241 "yacc.ypp"
                          { (yyval.nPtr) = FIM_OPR('x',1,FIM_SCON((yyvsp[0].sValue)));     }
#line 1583 "yacc.tab.cpp"
    break;

  case 42: /* statement: IDENTIFIER FILE_PATH  */
#line 242 "yacc.ypp"
                               {
#ifdef	FIM_SMART_COMPLETION
		/* This patch allows first filename argument unquoted. */
		(yyval.nPtr) = FIM_OPR('x',2,FIM_SCON((yyvsp[-1].sValue)),FIM_OPR('a',1,FIM_SCON(dupstr((yyvsp[0].sValue)))));
		fim_free((yyvsp[0].sValue));
#else
		(yyval.nPtr) = FIM_OPR('x',2,FIM_SCON(dupstr(FIM_FLT_ECHO)),FIM_OPR('a',1,FIM_SCON(dupstr("Please quote or double-quote your argument or enable FIM_SMART_COMPLETION at compile time\n"))));
#endif
		}
#line 1597 "yacc.tab.cpp"
    break;

  case 43: /* statement: IDENTIFIER arguments  */
#line 251 "yacc.ypp"
                               { (yyval.nPtr) = FIM_OPR('x',2,FIM_SCON((yyvsp[-1].sValue)),(yyvsp[0].nPtr));  /* here I would like to use FIM_SMART_COMPLETION but for now it works with the FILE_PATH trick above. */ }
#line 1603 "yacc.tab.cpp"
    break;

  case 44: /* statement: INTEGER IDENTIFIER arguments  */
#line 252 "yacc.ypp"
                                       { if((yyvsp[-2].iValue)>0){(yyval.nPtr) = FIM_OPR('r',2,FIM_OPR('x',2,FIM_SCON((yyvsp[-1].sValue)),(yyvsp[0].nPtr)),FIM_ICON((yyvsp[-2].iValue))); }}
#line 1609 "yacc.tab.cpp"
    break;

  case 45: /* statement: IDENTIFIER '=' expression  */
#line 254 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('=', 2, FIM_VSCON((yyvsp[-2].sValue),'a'), (yyvsp[0].nPtr)); }
#line 1615 "yacc.tab.cpp"
    break;

  case 46: /* arguments: expression  */
#line 284 "yacc.ypp"
                     { (yyval.nPtr) = FIM_OPR('a',1, (yyvsp[0].nPtr) ); }
#line 1621 "yacc.tab.cpp"
    break;

  case 47: /* arguments: expression arguments  */
#line 285 "yacc.ypp"
                               { (yyval.nPtr) = FIM_OPR('a', 2, (yyvsp[-1].nPtr), (yyvsp[0].nPtr)); }
#line 1627 "yacc.tab.cpp"
    break;

  case 48: /* expression: '(' expression ')'  */
#line 300 "yacc.ypp"
                             { (yyval.nPtr) = (yyvsp[-1].nPtr); }
#line 1633 "yacc.tab.cpp"
    break;

  case 49: /* expression: expression '.' expression  */
#line 301 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('.', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1639 "yacc.tab.cpp"
    break;

  case 50: /* expression: NOT expression  */
#line 302 "yacc.ypp"
                         { (yyval.nPtr) = FIM_OPR('!', 1, (yyvsp[0].nPtr)); }
#line 1645 "yacc.tab.cpp"
    break;

  case 51: /* expression: expression '%' expression  */
#line 303 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('%', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1651 "yacc.tab.cpp"
    break;

  case 52: /* expression: expression '+' expression  */
#line 304 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('+', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1657 "yacc.tab.cpp"
    break;

  case 53: /* expression: expression '-' expression  */
#line 305 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('-', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1663 "yacc.tab.cpp"
    break;

  case 54: /* expression: expression '*' expression  */
#line 306 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('*', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1669 "yacc.tab.cpp"
    break;

  case 55: /* expression: expression '/' expression  */
#line 307 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('/', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1675 "yacc.tab.cpp"
    break;

  case 56: /* expression: expression '<' expression  */
#line 308 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('<', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1681 "yacc.tab.cpp"
    break;

  case 57: /* expression: expression '>' expression  */
#line 309 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR('>', 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1687 "yacc.tab.cpp"
    break;

  case 58: /* expression: expression OR expression  */
#line 310 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR( OR , 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1693 "yacc.tab.cpp"
    break;

  case 59: /* expression: expression BOR expression  */
#line 311 "yacc.ypp"
                                     { (yyval.nPtr) = FIM_OPR( BOR , 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1699 "yacc.tab.cpp"
    break;

  case 60: /* expression: expression AND expression  */
#line 312 "yacc.ypp"
                                    { (yyval.nPtr) = FIM_OPR( AND, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1705 "yacc.tab.cpp"
    break;

  case 61: /* expression: expression BAND expression  */
#line 313 "yacc.ypp"
                                     { (yyval.nPtr) = FIM_OPR( BAND, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1711 "yacc.tab.cpp"
    break;

  case 62: /* expression: expression GE expression  */
#line 314 "yacc.ypp"
                                   { (yyval.nPtr) = FIM_OPR(GE, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1717 "yacc.tab.cpp"
    break;

  case 63: /* expression: expression LE expression  */
#line 315 "yacc.ypp"
                                   { (yyval.nPtr) = FIM_OPR(LE, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1723 "yacc.tab.cpp"
    break;

  case 64: /* expression: expression NE expression  */
#line 316 "yacc.ypp"
                                   { (yyval.nPtr) = FIM_OPR(NE, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1729 "yacc.tab.cpp"
    break;

  case 65: /* expression: expression EQ expression  */
#line 317 "yacc.ypp"
                                   { (yyval.nPtr) = FIM_OPR(EQ, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1735 "yacc.tab.cpp"
    break;

  case 66: /* expression: expression REGEXP_MATCH expression  */
#line 318 "yacc.ypp"
                                             { (yyval.nPtr) = FIM_OPR(REGEXP_MATCH, 2, (yyvsp[-2].nPtr), (yyvsp[0].nPtr)); }
#line 1741 "yacc.tab.cpp"
    break;

  case 67: /* expression: '-' expression  */
#line 326 "yacc.ypp"
                                      { (yyval.nPtr) = FIM_OPR(UMINUS, 1, (yyvsp[0].nPtr)); }
#line 1747 "yacc.tab.cpp"
    break;

  case 68: /* expression: IDENTIFIER  */
#line 329 "yacc.ypp"
                     { (yyval.nPtr) = FIM_VSCON((yyvsp[0].sValue),'v');  }
#line 1753 "yacc.tab.cpp"
    break;

  case 69: /* expression: INTEGER  */
#line 330 "yacc.ypp"
                  { (yyval.nPtr) =  FIM_ICON((yyvsp[0].iValue)); }
#line 1759 "yacc.tab.cpp"
    break;

  case 70: /* expression: QUOTED_FLOAT  */
#line 331 "yacc.ypp"
                         { (yyval.nPtr) = FIM_FCON((yyvsp[0].fValue)); }
#line 1765 "yacc.tab.cpp"
    break;

  case 71: /* expression: UNQUOTED_FLOAT  */
#line 332 "yacc.ypp"
                           { (yyval.nPtr) = FIM_FCON((yyvsp[0].fValue)); }
#line 1771 "yacc.tab.cpp"
    break;

  case 72: /* expression: STRING  */
#line 333 "yacc.ypp"
                  { (yyval.nPtr) = FIM_SCON((yyvsp[0].sValue)); }
#line 1777 "yacc.tab.cpp"
    break;


#line 1781 "yacc.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 336 "yacc.ypp"


/* See fim_interpreter.cpp */

